sub duplo_ui_ui_ui()
 REM		$Id$
 REM	Copyright (c) New Deal 1997 -- All Rights Reserved
 REM	FILE:		STDINC.BH

 STRUCT TimeOfDay
  DIM hour as integer
  DIM minute as integer
  DIM second as integer
 END STRUCT

 STRUCT Date
  DIM year as integer
  DIM month as integer
  DIM day as integer
 END STRUCT

 STRUCT Notification
  DIM arg1 as integer
  DIM arg2 as integer
  DIM arg3 as integer
  DIM arg4 as integer
  DIM arg5 as string
  DIM arg6 as complex
 END STRUCT

REM useful color constants
CONST WHITE 		&Hffffffff
CONST BLACK 		&Hff000000
CONST GRAY_50 		&Hff808080, GREY_50 		&Hff808080
CONST DARK_GRAY 	&Hff555555, LIGHT_GRAY		&Hffaaaaaa
CONST DARK_GREY 	&Hff555555, LIGHT_GREY		&Hffaaaaaa
CONST DARK_GREEN	&Hff00aa00, LIGHT_GREEN 	&Hff55ff55
CONST DARK_BLUE 	&Hff0000aa, LIGHT_BLUE		&Hff5555ff
CONST DARK_CYAN		&Hff00aaaa, LIGHT_CYAN		&Hff55ffff
CONST DARK_PURPLE	&Hffaa00aa, LIGHT_PURPLE	&Hffff55ff
CONST DARK_RED		&Hffaa0000, LIGHT_RED		&Hffff5555
CONST BROWN		&Hffaa5500, YELLOW		&Hffffff55

REM useful text style constants
CONST UNDERLINE		1
CONST STRIKE_THRU	2
CONST SUBSCRIPT		4
CONST SUPERSCRIPT	8
CONST ITALIC		16
CONST BOLD		32

REM useful Boolean constants
CONST TRUE		1
CONST FALSE		0

REM sound constants
CONST SS_ERROR		0
CONST SS_WARNING	1
CONST SS_NOTIFY		2
CONST SS_NO_INPUT	3
CONST SS_KEY_CLICK	4
CONST SS_ALARM		5

CONST MOUSE_PRESS 1, MOUSE_HOLD 2, MOUSE_DRAG 3, MOUSE_TO 4, MOUSE_RELEASE 5
CONST MOUSE_LOST 6, MOUSE_FLY_OVER 7

CONST C_SYS_00			&Hff00
CONST C_SYS_FF			&Hffff
CONST C_SYS_BACKSPACE		&Hff08
CONST C_SYS_TAB			&Hff09
CONST C_SYS_ENTER		&Hff0d
CONST C_SYS_ESCAPE		&Hff1b
CONST C_SYS_F1			&Hff80
CONST C_SYS_F2			&Hff81
CONST C_SYS_F3			&Hff82
CONST C_SYS_F4			&Hff83
CONST C_SYS_F5			&Hff84
CONST C_SYS_F6			&Hff85
CONST C_SYS_F7			&Hff86
CONST C_SYS_F8			&Hff87
CONST C_SYS_F9			&Hff88
CONST C_SYS_F10			&Hff89
CONST C_SYS_F11			&Hff8a
CONST C_SYS_F12			&Hff8b
CONST C_SYS_F13			&Hff8c
CONST C_SYS_F14			&Hff8d
CONST C_SYS_F15			&Hff8e
CONST C_SYS_F16			&Hff8f
CONST C_SYS_UP			&Hff90
CONST C_SYS_DOWN		&Hff91
CONST C_SYS_RIGHT		&Hff92
CONST C_SYS_LEFT		&Hff93
CONST C_SYS_HOME		&Hff94
CONST C_SYS_END			&Hff95
CONST C_SYS_PREVIOUS		&Hff96
CONST C_SYS_NEXT		&Hff97
CONST C_SYS_INSERT		&Hff98
CONST C_SYS_CLEAR		&Hff99	rem Not used in Geos.
CONST C_SYS_DELETE		&Hff9a
CONST C_SYS_PRINT_SCREEN	&Hff9b
CONST C_SYS_HELP		&Hff9d	rem Not used in Geos.
CONST C_SYS_BREAK		&Hff9e
CONST C_SYS_CAPS_LOCK		&Hffe8
CONST C_SYS_NUM_LOCK		&Hffe9
CONST C_SYS_SCROLL_LOCK		&Hffea
CONST C_SYS_LEFT_ALT		&Hffe0
CONST C_SYS_RIGHT_ALT		&Hffe1
CONST C_SYS_LEFT_CTRL		&Hffe2
CONST C_SYS_RIGHT_CTRL		&Hffe3
CONST C_SYS_LEFT_SHIFT		&Hffe4
CONST C_SYS_RIGHT_SHIFT		&Hffe5


CONST KEY_BS 		&Hff08
CONST KEY_DEL 		&Hff9a
CONST KEY_ENTER 	&Hff0d
CONST KEY_KP_RETURN 	&Hffff
CONST KEY_HOME		&Hff94
CONST KEY_TAB		&Hff09
CONST KEY_END		&Hff93
CONST KEY_ESC		&Hff1b
CONST KEY_UP_ARROW	&Hff90
CONST KEY_LEFT_ARROW	&Hff93
CONST KEY_RIGHT_ARROW	&Hff92
CONST KEY_DOWN_ARROW	&Hff91

REM date formats
CONST DTF_LONG				0
CONST DTF_LONG_CONDENSED		1
CONST DTF_LONG_NO_WEEKDAY		2
CONST DTF_LONG_NO_WEEKDAY_CONDENSED	3
CONST DTF_SHORT				4
CONST DTF_ZERO_PADDED_SHORT		5
CONST DTF_MD_LONG			6
CONST DTF_MD_LONG_NO_WEEKDAY		7
CONST DTF_MD_SHORT			8
CONST DTF_MY_LONG			9
CONST DTF_MY_SHORT			10
CONST DTF_YEAR				11
CONST DTF_MONTH				12
CONST DTF_DAY				13
CONST DTF_WEEKDAY			14
REM time formats
CONST DTF_HMS				15
CONST DTF_HM				16
CONST DTF_H				17
CONST DTF_MS				18
CONST DTF_HMS_24HOUR			19
CONST DTF_HM_24HOUR			20

REM pi
CONST PI 3.14159265359

REM Format() constants
CONST FFAF_SCIENTIFIC		&H100
CONST FFAF_PERCENT		&H80
CONST FFAF_USE_COMMAS		&H40
CONST FFAF_NO_TRAIL_ZEROS	&H20
CONST FFAF_NO_LEAD_ZERO		&H10

REM dim system as module
REM system = SystemModule()

 REM end of stdinc.bh

DisableEvents()
Dim form1 as form
form1 = MakeComponent("form","app")
CompInit form1
proto="form1"
top=52
left=334
tile=1
caption="NewBASIC"
End CompInit
Dim spacer1 as spacer
spacer1 = MakeComponent("spacer",form1)
CompInit spacer1
proto="spacer1"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
spacer1.name="spacer1"
Dim group1 as group
group1 = MakeComponent("group",form1)
CompInit group1
proto="group1"
caption="Animation : "
look=1
tile=1
sizeHControl=0
sizeVControl=0
height=257
width=264
visible=1
End CompInit
Dim picture1 as picture
picture1 = MakeComponent("picture",group1)
CompInit picture1
proto="picture1"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
picture1.name="picture1"
picture1.graphic=GetComplex(0)
Dim picture2 as picture
picture2 = MakeComponent("picture",group1)
CompInit picture2
proto="picture2"
sizeHControl=3
sizeVControl=3
End CompInit
picture2.name="picture2"
picture2.graphic=GetComplex(1)
Dim picture3 as picture
picture3 = MakeComponent("picture",group1)
CompInit picture3
proto="picture3"
sizeHControl=3
sizeVControl=3
End CompInit
picture3.name="picture3"
picture3.graphic=GetComplex(2)
Dim picture4 as picture
picture4 = MakeComponent("picture",group1)
CompInit picture4
proto="picture4"
sizeHControl=3
sizeVControl=3
End CompInit
picture4.name="picture4"
picture4.graphic=GetComplex(3)
Dim picture5 as picture
picture5 = MakeComponent("picture",group1)
CompInit picture5
proto="picture5"
sizeHControl=3
sizeVControl=3
End CompInit
picture5.name="picture5"
picture5.graphic=GetComplex(4)
Dim picture6 as picture
picture6 = MakeComponent("picture",group1)
CompInit picture6
proto="picture6"
sizeHControl=3
sizeVControl=3
End CompInit
picture6.name="picture6"
picture6.graphic=GetComplex(5)
Dim picture7 as picture
picture7 = MakeComponent("picture",group1)
CompInit picture7
proto="picture7"
sizeHControl=3
sizeVControl=3
End CompInit
picture7.graphic=GetComplex(6)
picture7.name="picture7"
Dim picture8 as picture
picture8 = MakeComponent("picture",group1)
CompInit picture8
proto="picture8"
sizeHControl=3
sizeVControl=3
End CompInit
picture8.graphic=GetComplex(7)
picture8.name="picture8"
Dim picture9 as picture
picture9 = MakeComponent("picture",group1)
CompInit picture9
proto="picture9"
sizeHControl=3
sizeVControl=3
End CompInit
picture9.graphic=GetComplex(8)
picture9.name="picture9"
Dim picture10 as picture
picture10 = MakeComponent("picture",group1)
CompInit picture10
proto="picture10"
sizeHControl=3
sizeVControl=3
End CompInit
picture10.graphic=GetComplex(9)
picture10.name="picture10"
Dim picture11 as picture
picture11 = MakeComponent("picture",group1)
CompInit picture11
proto="picture11"
sizeHControl=3
sizeVControl=3
End CompInit
picture11.graphic=GetComplex(10)
picture11.name="picture11"
group1.name="group1"
Dim spacer3 as spacer
spacer3 = MakeComponent("spacer",form1)
CompInit spacer3
proto="spacer3"
visible=1
End CompInit
spacer3.name="spacer3"
Dim start_but as button
start_but = MakeComponent("button",form1)
CompInit start_but
proto="start_but"
caption="Start !"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
start_but.name="start_but"
form1.name="form1"
form1.height=352
form1.width=282
Dim timer1 as timer
timer1 = MakeComponent("timer","app")
CompInit timer1
proto="timer1"
End CompInit
timer1.name="timer1"
EnableEvents()
duplo_start()
end sub

sub duplo_start()
module_show()

'This little sample app shows how to quickly create animations using the
'internal GetComplex(RscNr) Function. See timer1_ring() for more information.

DIM index AS INTEGER
DIM op AS STRING
DIM up_limit AS INTEGER
DIM low_limit AS INTEGER

up_limit = 11
low_limit = 0
index = low_limit
op = "up"
picture1.graphic = GetComplex(index)
timer1.interval = 8	'Increase this value on slower computers

end sub

sub module_goTo(context as string)

end sub

function module_getContext()

module_getContext = ""

end function

sub module_show()
REM code for making this module appear
form1.visible=1

end sub

sub module_hide()
REM code for making this module disappear
form1.visible=0

end sub

sub module_exit()

end sub

sub start_but_pressed(self as button)

IF timer1.enabled = TRUE THEN
	timer1.enabled = FALSE
	start_but.caption = "Start !"
ELSE
	timer1.enabled = TRUE
	start_but.caption = "Stop  !"
END IF

end sub

sub timer1_ring(self as timer)

	IF (op = "up") THEN
		index = index + 1
		IF (index = up_limit) THEN
			op = "down"
		END IF
	END IF
	IF (op = "down") THEN
		index = index - 1
		IF (index = low_limit - 1) THEN
			index = low_limit
			op = "up"
		END IF
	END IF

	picture1.graphic = GetComplex(index)

end sub

