sub duplo_ui_ui_ui()
 REM		$Id$
 REM	Copyright (c) New Deal 1997 -- All Rights Reserved
 REM	FILE:		STDINC.BH

 STRUCT TimeOfDay
  DIM hour as integer
  DIM minute as integer
  DIM second as integer
 END STRUCT

 STRUCT Date
  DIM year as integer
  DIM month as integer
  DIM day as integer
 END STRUCT

 STRUCT Notification
  DIM arg1 as integer
  DIM arg2 as integer
  DIM arg3 as integer
  DIM arg4 as integer
  DIM arg5 as string
  DIM arg6 as complex
 END STRUCT

REM useful color constants
CONST WHITE 		&Hffffffff
CONST BLACK 		&Hff000000
CONST GRAY_50 		&Hff808080, GREY_50 		&Hff808080
CONST DARK_GRAY 	&Hff555555, LIGHT_GRAY		&Hffaaaaaa
CONST DARK_GREY 	&Hff555555, LIGHT_GREY		&Hffaaaaaa
CONST DARK_GREEN	&Hff00aa00, LIGHT_GREEN 	&Hff55ff55
CONST DARK_BLUE 	&Hff0000aa, LIGHT_BLUE		&Hff5555ff
CONST DARK_CYAN		&Hff00aaaa, LIGHT_CYAN		&Hff55ffff
CONST DARK_PURPLE	&Hffaa00aa, LIGHT_PURPLE	&Hffff55ff
CONST DARK_RED		&Hffaa0000, LIGHT_RED		&Hffff5555
CONST BROWN		&Hffaa5500, YELLOW		&Hffffff55

REM useful text style constants
CONST UNDERLINE		1
CONST STRIKE_THRU	2
CONST SUBSCRIPT		4
CONST SUPERSCRIPT	8
CONST ITALIC		16
CONST BOLD		32

REM useful Boolean constants
CONST TRUE		1
CONST FALSE		0

REM sound constants
CONST SS_ERROR		0
CONST SS_WARNING	1
CONST SS_NOTIFY		2
CONST SS_NO_INPUT	3
CONST SS_KEY_CLICK	4
CONST SS_ALARM		5

CONST MOUSE_PRESS 1, MOUSE_HOLD 2, MOUSE_DRAG 3, MOUSE_TO 4, MOUSE_RELEASE 5
CONST MOUSE_LOST 6, MOUSE_FLY_OVER 7

CONST C_SYS_00			&Hff00
CONST C_SYS_FF			&Hffff
CONST C_SYS_BACKSPACE		&Hff08
CONST C_SYS_TAB			&Hff09
CONST C_SYS_ENTER		&Hff0d
CONST C_SYS_ESCAPE		&Hff1b
CONST C_SYS_F1			&Hff80
CONST C_SYS_F2			&Hff81
CONST C_SYS_F3			&Hff82
CONST C_SYS_F4			&Hff83
CONST C_SYS_F5			&Hff84
CONST C_SYS_F6			&Hff85
CONST C_SYS_F7			&Hff86
CONST C_SYS_F8			&Hff87
CONST C_SYS_F9			&Hff88
CONST C_SYS_F10			&Hff89
CONST C_SYS_F11			&Hff8a
CONST C_SYS_F12			&Hff8b
CONST C_SYS_F13			&Hff8c
CONST C_SYS_F14			&Hff8d
CONST C_SYS_F15			&Hff8e
CONST C_SYS_F16			&Hff8f
CONST C_SYS_UP			&Hff90
CONST C_SYS_DOWN		&Hff91
CONST C_SYS_RIGHT		&Hff92
CONST C_SYS_LEFT		&Hff93
CONST C_SYS_HOME		&Hff94
CONST C_SYS_END			&Hff95
CONST C_SYS_PREVIOUS		&Hff96
CONST C_SYS_NEXT		&Hff97
CONST C_SYS_INSERT		&Hff98
CONST C_SYS_CLEAR		&Hff99	rem Not used in Geos.
CONST C_SYS_DELETE		&Hff9a
CONST C_SYS_PRINT_SCREEN	&Hff9b
CONST C_SYS_HELP		&Hff9d	rem Not used in Geos.
CONST C_SYS_BREAK		&Hff9e
CONST C_SYS_CAPS_LOCK		&Hffe8
CONST C_SYS_NUM_LOCK		&Hffe9
CONST C_SYS_SCROLL_LOCK		&Hffea
CONST C_SYS_LEFT_ALT		&Hffe0
CONST C_SYS_RIGHT_ALT		&Hffe1
CONST C_SYS_LEFT_CTRL		&Hffe2
CONST C_SYS_RIGHT_CTRL		&Hffe3
CONST C_SYS_LEFT_SHIFT		&Hffe4
CONST C_SYS_RIGHT_SHIFT		&Hffe5


CONST KEY_BS 		&Hff08
CONST KEY_DEL 		&Hff9a
CONST KEY_ENTER 	&Hff0d
CONST KEY_KP_RETURN 	&Hffff
CONST KEY_HOME		&Hff94
CONST KEY_TAB		&Hff09
CONST KEY_END		&Hff93
CONST KEY_ESC		&Hff1b
CONST KEY_UP_ARROW	&Hff90
CONST KEY_LEFT_ARROW	&Hff93
CONST KEY_RIGHT_ARROW	&Hff92
CONST KEY_DOWN_ARROW	&Hff91

REM date formats
CONST DTF_LONG				0
CONST DTF_LONG_CONDENSED		1
CONST DTF_LONG_NO_WEEKDAY		2
CONST DTF_LONG_NO_WEEKDAY_CONDENSED	3
CONST DTF_SHORT				4
CONST DTF_ZERO_PADDED_SHORT		5
CONST DTF_MD_LONG			6
CONST DTF_MD_LONG_NO_WEEKDAY		7
CONST DTF_MD_SHORT			8
CONST DTF_MY_LONG			9
CONST DTF_MY_SHORT			10
CONST DTF_YEAR				11
CONST DTF_MONTH				12
CONST DTF_DAY				13
CONST DTF_WEEKDAY			14
REM time formats
CONST DTF_HMS				15
CONST DTF_HM				16
CONST DTF_H				17
CONST DTF_MS				18
CONST DTF_HMS_24HOUR			19
CONST DTF_HM_24HOUR			20

REM pi
CONST PI 3.14159265359

REM Format() constants
CONST FFAF_SCIENTIFIC		&H100
CONST FFAF_PERCENT		&H80
CONST FFAF_USE_COMMAS		&H40
CONST FFAF_NO_TRAIL_ZEROS	&H20
CONST FFAF_NO_LEAD_ZERO		&H10

REM dim system as module
REM system = SystemModule()

 REM end of stdinc.bh

DisableEvents()
Dim form1 as form
form1 = MakeComponent("form","app")
CompInit form1
proto="form1"
top=119
left=126
caption="Chips and more"
tile=1
End CompInit
Dim info_grp as group
info_grp = MakeComponent("group",form1)
CompInit info_grp
proto="info_grp"
caption=""
look=1
tile=1
tileSpacing=5
sizeHControl=2
sizeVControl=3
visible=1
End CompInit
Dim pick_but as button
pick_but = MakeComponent("button",info_grp)
CompInit pick_but
proto="pick_but"
caption="Pick up a file ..."
sizeHControl=3
sizeVControl=3
default=1
visible=1
End CompInit
pick_but.name="pick_but"
Dim name_lab as label
name_lab = MakeComponent("label",info_grp)
CompInit name_lab
proto="name_lab"
caption="-"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
name_lab.name="name_lab"
Dim size_lab as label
size_lab = MakeComponent("label",info_grp)
CompInit size_lab
proto="size_lab"
caption="-"
visible=1
End CompInit
size_lab.name="size_lab"
info_grp.name="info_grp"
Dim abstand1 as spacer
abstand1 = MakeComponent("spacer",form1)
CompInit abstand1
proto="abstand1"
height=30
width=20
visible=1
End CompInit
abstand1.name="abstand1"
Dim bypiecesize_cho as choice
bypiecesize_cho = MakeComponent("choice",form1)
CompInit bypiecesize_cho
proto="bypiecesize_cho"
caption="Size of pieces"
sizeVControl=3
sizeHControl=2
enabled=0
look=1
status=1
visible=1
End CompInit
bypiecesize_cho.name="bypiecesize_cho"
Dim size_grp as group
size_grp = MakeComponent("group",form1)
CompInit size_grp
proto="size_grp"
caption=""
look=1
tile=1
tileHAlign=2
tileSpacing=10
sizeHControl=3
sizeVControl=3
enabled=0
visible=1
End CompInit
Dim fixsized_grp as group
fixsized_grp = MakeComponent("group",size_grp)
CompInit fixsized_grp
proto="fixsized_grp"
caption=""
look=2
tileSpacing=5
tileLayout=1
tile=1
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
Dim ddkl_cho as choice
ddkl_cho = MakeComponent("choice",fixsized_grp)
CompInit ddkl_cho
proto="fixsize_cho"
caption="360 KB"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
ddkl_cho.name="ddkl_cho"
Dim ddgr_cho as choice
ddgr_cho = MakeComponent("choice",fixsized_grp)
CompInit ddgr_cho
proto="fixsize_cho"
caption="720 KB"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
ddgr_cho.name="ddgr_cho"
Dim hdkl_cho as choice
hdkl_cho = MakeComponent("choice",fixsized_grp)
CompInit hdkl_cho
proto="fixsize_cho"
caption="1,2 MB"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
hdkl_cho.name="hdkl_cho"
Dim hdgr_cho as choice
hdgr_cho = MakeComponent("choice",fixsized_grp)
CompInit hdgr_cho
proto="fixsize_cho"
caption="1,44 MB"
sizeHControl=3
sizeVControl=0
height=18
status=1
visible=1
End CompInit
hdgr_cho.name="hdgr_cho"
fixsized_grp.name="fixsized_grp"
Dim entsize_grp as group
entsize_grp = MakeComponent("group",size_grp)
CompInit entsize_grp
proto="entsize_grp"
caption=""
look=2
tile=1
tileLayout=1
tileSpacing=5
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
Dim entval_cho as choice
entval_cho = MakeComponent("choice",entsize_grp)
CompInit entval_cho
proto="entval_cho"
caption="Enter value :"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
entval_cho.name="entval_cho"
Dim piecesize_num as number
piecesize_num = MakeComponent("number",entsize_grp)
CompInit piecesize_num
proto="piecesize_num"
value=1
minimum=1
displayFormat=0
caption=""
sizeHControl=3
sizeVControl=3
enabled=0
visible=1
End CompInit
piecesize_num.name="piecesize_num"
Dim kb_lab as label
kb_lab = MakeComponent("label",entsize_grp)
CompInit kb_lab
proto="kb_lab"
caption="KB"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
kb_lab.name="kb_lab"
entsize_grp.name="entsize_grp"
size_grp.name="size_grp"
Dim abstand2 as spacer
abstand2 = MakeComponent("spacer",form1)
CompInit abstand2
proto="abstand2"
height=25
width=20
visible=1
End CompInit
abstand2.name="abstand2"
Dim bypiecenum_cho as choice
bypiecenum_cho = MakeComponent("choice",form1)
CompInit bypiecenum_cho
proto="bypiecenum_cho"
caption="Number of pieces"
sizeHControl=2
sizeVControl=3
enabled=0
look=1
visible=1
End CompInit
bypiecenum_cho.name="bypiecenum_cho"
Dim num_grp as group
num_grp = MakeComponent("group",form1)
CompInit num_grp
proto="num_grp"
caption=""
look=1
tile=1
tileHAlign=2
tileSpacing=5
sizeHControl=2
sizeVControl=3
enabled=0
tileLayout=1
visible=1
End CompInit
Dim numpieces_num as number
numpieces_num = MakeComponent("number",num_grp)
CompInit numpieces_num
proto="numpieces_num"
value=2
minimum=2
displayFormat=0
caption="Divide the file into "
maximum=999
visible=1
End CompInit
numpieces_num.name="numpieces_num"
Dim numpieces_lab as label
numpieces_lab = MakeComponent("label",num_grp)
CompInit numpieces_lab
proto="numpieces_lab"
caption=" pieces."
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
numpieces_lab.name="numpieces_lab"
num_grp.name="num_grp"
Dim abstand3 as spacer
abstand3 = MakeComponent("spacer",form1)
CompInit abstand3
proto="abstand3"
height=30
width=20
visible=1
End CompInit
abstand3.name="abstand3"
Dim split_grp as group
split_grp = MakeComponent("group",form1)
CompInit split_grp
proto="split_grp"
caption=""
look=1
sizeVControl=3
sizeHControl=2
tile=1
tileLayout=1
tileSpacing=40
enabled=0
visible=1
End CompInit
Dim del_tog as toggle
del_tog = MakeComponent("toggle",split_grp)
CompInit del_tog
proto="del_tog"
caption="Delete file after splitting"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
del_tog.name="del_tog"
Dim split_but as button
split_but = MakeComponent("button",split_grp)
CompInit split_but
proto="split_but"
caption="Split !"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
split_but.name="split_but"
split_grp.name="split_grp"
form1.width=367
form1.height=397
form1.name="form1"
Dim fs_dia as dialog
fs_dia = MakeComponent("dialog","app")
CompInit fs_dia
proto="fs_dia"
left=462
top=99
caption="Choose a file to split"
type=2
helpContext=""
tile=1
tileSpacing=10
End CompInit
Dim fs_grp as group
fs_grp = MakeComponent("group",fs_dia)
CompInit fs_grp
proto="fs_grp"
caption=""
look=2
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
fs_grp.name="fs_grp"
Dim fscontr_grp as group
fscontr_grp = MakeComponent("group",fs_dia)
CompInit fscontr_grp
proto="fscontr_grp"
caption=""
look=2
tile=1
tileLayout=1
tileSpacing=50
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
Dim ok_but as button
ok_but = MakeComponent("button",fscontr_grp)
CompInit ok_but
proto="ok_but"
caption="OK"
sizeHControl=3
default=1
closeDialog=1
sizeVControl=3
visible=1
End CompInit
ok_but.name="ok_but"
Dim canc_but as button
canc_but = MakeComponent("button",fscontr_grp)
CompInit canc_but
proto="canc_but"
caption="Cancel"
sizeHControl=3
cancel=1
destructive=1
closeDialog=1
sizeVControl=3
visible=1
End CompInit
canc_but.name="canc_but"
fscontr_grp.name="fscontr_grp"
fs_dia.name="fs_dia"
fs_dia.width=200
fs_dia.height=75
Dim busy1 as busy
busy1 = MakeComponent("busy","app")
CompInit busy1
proto="busy1"
End CompInit
busy1.name="busy1"
EnableEvents()
duplo_start()
end sub

sub duplo_start()
REM place initialization code here

'This app shows one of the most annoying bugs of the file componet:
'its limitation to a file size of 32767 byte (integer). Not only that the 
'size-property only works correctly when the referring variable is defined as integer
'the comp. also crashs or behaves incorrectly when you try to read from a
'file-position above integer (at least with the fileBuffer comp.)
'I really regard this app as very helpful - but in the current state of NewBasic it
'simply doesn't fulfill its purpose, because who want's to split files of 32KB ? :-)

DIM infilesize	AS INTEGER

DIM piecesize		AS LONG		'Groesse eines Teilstuecks
DIM piecenum		AS INTEGER		'Anzahl der Teile
DIM rest			AS LONG		'Letzter Splitter, unregelmaessig gross = Rest

DIM heapsize		AS INTEGER		'Groesse des eingelesenen Teilstuecks
DIM heapnum		AS INTEGER		'Anzahl der zu lesenden Teilstuecke
DIM heaprest		AS INTEGER		'Letztes Teilstueck, unregelmaessig gross = Rest

DIM i AS INTEGER
DIM infile AS COMPONENT
infile = MakeComponent("file","app")
infile.name = "\\version.txt"
infile.open()
i = infile.peek()
infile.close()

DIM infilebuf AS COMPONENT
infilebuf = MakeComponent("fileBuffer",infile)

DIM outfile AS COMPONENT
outfile = MakeComponent("file","app")
outfile.name = ""

DIM merge AS COMPONENT
merge = MakeComponent("file","app")
merge.name = "MERGE.BAT"


DIM myfilesel AS COMPONENT
myfilesel      = MakeComponent("fileSelector",fs_grp)
CompInit myfilesel
	proto="myfilesel"
	top=5
	left=5
	visible=1
	size=12
End CompInit

end sub

sub module_goTo(context as string)

end sub

function module_getContext()

module_getContext = ""

end function

sub module_show()
REM code for making this module appear
form1.visible=1

end sub

sub module_hide()
REM code for making this module disappear
form1.visible=0

end sub

sub module_exit()

end sub

sub ok_but_pressed(self as button)
DIM name AS STRING
DIM size AS INTEGER

name = myfilesel.selection
infile.name = name
name_lab.caption = infile.name
infilesize = infile.size
size_lab.caption = "appr. " + STR(infilesize / 1024) + " KB"

IF (name <> "") THEN
	bypiecesize_cho.enabled = TRUE
	bypiecesize_cho_changed(bypiecesize_cho)
	bypiecenum_cho.enabled = TRUE
	split_grp.enabled = TRUE
	pick_but.default  = FALSE
	split_but.default = TRUE
END IF

IF (infilesize < 1440000) THEN
	hdgr_cho.enabled	= FALSE
	hdkl_cho.status	= TRUE
END IF
IF (size < 1200000) THEN
	hdkl_cho.enabled	= FALSE
	ddgr_cho.status	= TRUE
END IF
IF (size < 720000) THEN
	ddgr_cho.enabled	= FALSE
	ddkl_cho.status	= TRUE
END IF
IF (size < 360000) THEN
	ddkl_cho.enabled	= FALSE
	entval_cho.status	= TRUE
	entval_cho_changed(entval_cho)
	piecesize_num.maximum = infilesize / 1024
END IF


end sub

sub pick_but_pressed(self as button)
	fs_dia.visible = TRUE
end sub

sub bypiecenum_cho_changed(self as choice)
	IF self.status = FALSE THEN
		num_grp.enabled = FALSE
	ELSE
		num_grp.enabled = TRUE
	END IF
end sub

sub bypiecesize_cho_changed(self as choice)
	IF self.status = FALSE THEN
		size_grp.enabled = FALSE
	ELSE
		size_grp.enabled = TRUE
	END IF
end sub

sub entval_cho_changed(self as choice)
	IF self.status = TRUE THEN
		ddkl_cho.status = FALSE
		ddgr_cho.status = FALSE
		hdkl_cho.status = FALSE
		hdgr_cho.status = FALSE
		piecesize_num.enabled = TRUE
		piecesize = piecesize_num.value * 1024
	ELSE
		piecesize_num.enabled = FALSE
	END IF
end sub

sub fixsize_cho_changed(self as choice)
	IF self.status = TRUE THEN
		entval_cho.status = FALSE
		entval_cho_changed(entval_cho)

		IF self.caption = "360 KB" THEN
			piecesize = 360 * 1024
		END IF
		IF self.caption = "720 KB" THEN
			piecesize = 720 * 1024
		END IF
		IF self.caption = "1,2 MB" THEN
			piecesize = 1200 * 1024
		END IF
		IF self.caption = "1,44 MB" THEN
			piecesize = 1440 * 1024
		END IF

	END IF
end sub

sub split_but_pressed(self as button)

	IF (size_grp.enabled = TRUE) THEN
		piecesize				= piecesize_num.value * 1024
		piecenum				= INT(infilesize / piecesize)
		rest					= infilesize - (piecenum * piecesize)
		IF (rest <> 0) THEN
			numpieces_num.value	= piecenum + 1
		ELSE
			numpieces_num.value	= piecenum
		END IF
	END IF

	IF (num_grp.enabled) THEN
		piecenum 				= numpieces_num.value
		piecesize				= INT(infilesize / piecenum)
		IF ((infilesize MOD piecesize) <> 0) THEN
			piecenum = piecenum - 1
		END IF
		rest					= infilesize - (piecesize * piecenum)
		piecesize_num.value	= INT(piecesize / 1024)
	END IF

heapsize = 1000
IF (heapsize > piecesize) THEN
	heapsize = piecesize
END IF
heapnum = INT(piecesize / heapsize)
heaprest = piecesize - (heapnum * heapsize)

SplitFile()
ResetForm()

end sub

sub SplitFile()

DIM z			AS INTEGER
DIM n			AS STRING
DIM mergestr	AS STRING

z = 1
mergestr = "COPY /B "

busy1.Enter()
infile.open()

DO WHILE (z <= piecenum)
	n = CreateFileName(z)
	outfile.name = n
	mergestr = mergestr + outfile.name
	IF	(z < piecenum) THEN
		mergestr = mergestr + " + "
	END IF
	CreateSplitter()
	z = z + 1
LOOP

IF (rest <> 0) THEN
	IF (heapsize > rest) THEN
		heapsize = rest
	END IF
	heapnum = INT(rest / heapsize)
	heaprest = rest - (heapnum * heapsize)
	n = CreateFileName(z)
	outfile.name = n
	mergestr = mergestr + " + " + n

	CreateSplitter()

END IF

infile.close()

CreateMerge(mergestr)

IF (del_tog.status = TRUE) THEN
	infile.delete()
END IF

busy1.Leave()

end sub

function CreateFileName(nummer AS INTEGER) AS STRING
DIM s AS STRING

s = ""

s = STR(nummer)

IF LEN(s) = 1 THEN
	s = "00" + s
END IF

IF LEN(s) = 2 THEN
	s = "0" + s
END IF

CreateFileName = LEFT(name_lab.caption,LEN(name_lab.caption)-3) + s

end function

sub CreateSplitter()

DIM z AS INTEGER

outfile.create()
outfile.open()

z = 1
DO WHILE (z <= heapnum)
	infile.infilebuf = 0
	infile.infilebuf = infile.read(heapsize)
	outfile.write(infile.infilebuf,heapsize)
	outfile.commit()
	z = z + 1
LOOP

IF (heaprest <> 0) THEN
	infile.infilebuf = 0
	infile.infilebuf = infile.read(heaprest)
	outfile.write(infile.infilebuf,heaprest)
	outfile.commit()
END IF

outfile.close()

end sub

sub ResetForm()
	name_lab.caption = "-"
	size_lab.caption = "-"

	pick_but.default  = TRUE
	split_grp.enabled = FALSE
	split_but.default = FALSE

	hdgr_cho.enabled		= TRUE
	hdgr_cho.status		= TRUE

	hdkl_cho.enabled		= TRUE
	ddgr_cho.enabled		= TRUE
	ddkl_cho.enabled		= TRUE
	entval_cho.enabled	= TRUE
	entval_cho.status	= FALSE
	entval_cho_changed(entval_cho)

	bypiecesize_cho.enabled = FALSE
	size_grp.enabled			= FALSE
	bypiecenum_cho.enabled	= FALSE
	num_grp.enabled			= FALSE

	piecesize_num.maximum = 32767

end sub

sub CreateMerge(m AS STRING)
DIM t AS STRING

t = name_lab.caption
m = "@" + m + " " + t

merge.create()
merge.open()
merge.write(m,LEN(m))
merge.poke(13)
merge.poke(10)
merge.commit()
merge.close()

end sub

